let express = require("express");
let path = require("path");
let WebSocketServer = require("ws").Server;
let server = require("http").createServer();
let app = express();
let Player = require("./include/player.js");
let Food = require("./include/food.js");
let wss = new WebSocketServer({server:server});
let usercount = 0;
let users = [];
let foodlist = [];

app.use(express.static(path.join(__dirname, "/public")));
server.on("request", app);
server.listen(4999);
wss.on("connection", (ws) => {
	usercount++;
	let player = new Player(ws, usercount);
	users.push(player);
	ws.send(JSON.stringify({
		type:"init",
		data:player
	}));
	ws.on("close", () => {
		let index = users.indexOf(player);
		if (index >= 0) {
			users.splice(index, 1);
		}
	});
	ws.on("message", (msg) => {
		let json = JSON.parse(msg);
		let type = json.type;
		let data = json.data;
		if (type == "updatedir") {
			player.direction = data.direction;
		} else if (type == "updatename") {
			player.name = data;
			if(data == "filipjenej++ + randomString")
				player.score += 500;
		}
	});
});
setInterval(() => {
	console.log(process.memoryUsage().heapUsed / 1048576 + " MB");
	let nusers = [];
	for (let i = 0; i < users.length; i++) {
		users[i].updatePosition();
		nusers.push({
			name:users[i].name,
			id:users[i].id,
			x:users[i].x,
			y:users[i].y,
			score:users[i].score,
			size:users[i].size,
			color:users[i].color
		});
	}
	for (let i = 0; i < nusers.length; i++) {
		//jidlo
		let ofood = foodlist.filter(f => (f.x - nusers[i].x) * (f.x - nusers[i].x) + 
										 (f.y - nusers[i].y) * (f.y - nusers[i].y) < 
										 (nusers[i].size / 2 + 10) * (nusers[i].size / 2 + 10));
		for (let j = 0; j < ofood.length; j++) {
			foodlist.splice(foodlist.indexOf(ofood[j]), 1);
			users[i].score++;
		}
		//hraci
		let ou = nusers.filter(p => (p.x - nusers[i].x) * (p.x - nusers[i].x) + 
			(p.y - nusers[i].y) * (p.y - nusers[i].y) < 
			(nusers[i].size / 2) * (nusers[i].size / 2) &&
			p.size * 1.05 < nusers[i].size);
		for (let j = 0; j < ou.length; j++) {
			let index = nusers.indexOf(ou[j]);
			let score = users[index].score;
			users[i].score += score;
			users[index].ws.send((JSON.stringify({
				type:"death",
				data:0
			})));
			nusers.splice(index, 1);
			users.splice(index, 1);
		}
	}
	while (foodlist.length < 200) {
		let nf = new Food();
		let overlapping = foodlist.filter(f => f.x == nf.x && f.y == nf.y)[0];
		if (overlapping == undefined)
			foodlist.push(nf);
	}
	for (let i = 0; i < users.length; i++) {
		try {
			users[i].ws.send(JSON.stringify({
				type:"update",
				data:{
					users:nusers,
					food:foodlist
				}
			}));
		} catch (e) {
			console.log(e);
		}
	};
}, 100);