let game = document.querySelector(".game");
let ws = new WebSocket(location.origin.replace(/^http/, "ws"));
let users = [];
let food = [];
let mousepos = {
	x:0,
	y:0
};
let pl = new Player(game);
document.onmousemove = (event) => {
	mousepos.x = event.clientX - window.innerWidth / 2;
	mousepos.y = event.clientY - window.innerHeight / 2;
	let dir = Math.atan2(mousepos.x, mousepos.y);
	pl.direction = dir;
};
users.push(pl);
ws.onmessage = (msg) => {
	let json = JSON.parse(msg.data);
	let type = json.type;
	let data = json.data;
	if (type == "init") {
		pl.x = data.x;
		pl.y = data.y;
		pl.id = data.id;
		pl.color = data.color;
		pl.score = data.scorec;
		pl.ssize = data.size;
		let name = prompt("Enter your name:").trim();
		if (name == "" || name == undefined) {
			name = "<unnamed " + pl.id + ">";
		}
		pl.name = name;
		ws.send(JSON.stringify({
			type:"updatename",
			data:name
		}));
	} else if (type == "update") {
		if (pl.id == undefined)
			return;
		//hraci
		for (let i = 0; i < data.users.length; i++) {
			let p = users.filter(p => p.id == data.users[i].id)[0];
			if (p == undefined) {
				p = new Player(game);
				users.push(p);
				p.id = data.users[i].id;
				p.color = data.users[i].color;
			}
			p.x = data.users[i].x;
			p.y = data.users[i].y;
			p.score = data.users[i].scorec;
			p.ssize = data.users[i].size;
			p.sname = data.users[i].name;
		}
		let zustavajici = [];
		for (let i = 0; i < users.length; i++) {
			for (let j = 0; j < data.users.length; j++) {
				if (users[i].id == data.users[j].id) {
					zustavajici.push(users[i]);
				}
			}
		}
		for (let i = 0; i < users.length; i++) {
			let index = zustavajici.indexOf(users[i]);
			if (index == -1) {
				users[i].element.remove();
				users.splice(i, 1);
				i--;
			}
		}
		//jidlo
		for (let i = 0; i < data.food.length; i++) {
			let f = food.filter(f => data.food[i].x == f.x && data.food[i].y == f.y)[0];
			if (f == undefined) {
				f = new Food(game);
				f.x = data.food[i].x;
				f.y = data.food[i].y;
				f.color = data.food[i].color;
				food.push(f);
			}
		}
		zustavajici = [];
		for (let i = 0; i < food.length; i++) {
			for (let j = 0; j < data.food.length; j++) {
				if (food[i].x == data.food[j].x && food[i].y == data.food[j].y) {
					zustavajici.push(food[i]);
				}
			}
		}
		for (let i = 0; i < food.length; i++) {
			let index = zustavajici.indexOf(food[i]);
			if (index == -1) {
				food[i].element.remove();
				food.splice(i, 1);
				i--;
			}
		}
		game.style.left = (window.innerWidth / 2 - pl.x + 1000) + "px";
		game.style.top = (window.innerHeight / 2 - pl.y + 1000) + "px";
		let userctext = document.getElementById("usercount");
		userctext.textContent = data.users.length + " user(s)";
	} else if (type == "death") {
		alert("D:");
	}
};
setInterval(() => {
	if (pl.id == undefined)
		return;
	ws.send(JSON.stringify({
		type:"updatedir",
		data:{direction:pl.direction}
	}));
}, 100);